////////////////////////////////////////////
//
//     FAR Desktop.
//  (c) 2009  
//
//   
//
////////////////////////////////////////////

library FARDesktop;

//     
//  SysUtils  Classes.    
//        ,
//    

uses
  Windows, MySysUtils, MyClasses, Plugin, ActivateThread;

type
  TInitDialogItem=packed record
    ItemType:integer;
    X1,Y1,X2,Y2:integer;
    Data:integer;
    end;
  TInitDialogItemArr=packed array[0..5] of TInitDialogItem;

const
  conf_dialog:TInitDialogItemArr=
    (
    (ItemType:DI_DOUBLEBOX;  X1:2;  Y1:1; X2:38; Y2:8; Data:6),
    (ItemType:DI_CHECKBOX;   X1:4;  Y1:3; X2:15; Y2:3; Data:7),
    (ItemType:DI_CHECKBOX;   X1:4;  Y1:4; X2:15; Y2:4; Data:8),
    (ItemType:DI_CHECKBOX;   X1:4;  Y1:5; X2:15; Y2:5; Data:9),
    (ItemType:DI_BUTTON;     X1:11; Y1:7; X2:16; Y2:7; Data:10),
    (ItemType:DI_BUTTON;     X1:20; Y1:7; X2:29; Y2:7; Data:11)
    );

var
  far_api:TPluginStartupInfo;
  plugin_menu:array[0..5] of PChar;
  plugin_name:array[0..0] of PChar;

  far_handle:HWND=0;
  far_rect:TRect;
  at:TActivateThread;

  brd_sz,cpt_sz:integer;
  r1,r2,rboth:HRGN;
  old_place:TWindowPlacement;
  old_buf:COORD;

  show_p1:boolean=true;
  show_p2:boolean=true;
  show_both:boolean=true;

  show_captions,auto_maximize,append_bottom:boolean;

function GetConsoleWindow:HWND; external kernel32 name 'GetConsoleWindow';

function GetMsg(MsgId:integer):PChar;
begin
Result:=far_api.GetMsg(far_api.ModuleNumber,MsgId);
end;

procedure GetPluginInfo(var pi:TPluginInfo); stdcall;
begin
pi.StructSize:=SizeOf(pi);
pi.Flags:=PF_PRELOAD;

plugin_name[0]:=GetMsg(0);
pi.PluginMenuStrings:=@plugin_name;
pi.PluginMenuStringsNumber:=1;
pi.PluginConfigStrings:=@plugin_name;
pi.PluginConfigStringsNumber:=1;
end;

//        
procedure MaximizeFAR;
var
  con_info:CONSOLE_SCREEN_BUFFER_INFO;
  rc,rc2:TRect;
  cs,fs,ts:COORD;
  i:integer;
begin
//     
far_handle:=GetConsoleWindow;

//      , 
//          
GetWindowRect(far_handle,rc);
GetClientRect(far_handle,rc2);
brd_sz:=(rc.Right-rc.Left-rc2.Right+rc2.Left) div 2;
cpt_sz:=(rc.Bottom-rc.Top-rc2.Bottom+rc2.Top)-brd_sz;

//         
GetConsoleScreenBufferInfo(GetStdHandle(STD_OUTPUT_HANDLE),con_info);
fs.X:=(rc2.Right-rc2.Left) div con_info.dwSize.X;
fs.Y:=(rc2.Bottom-rc2.Top) div con_info.dwSize.Y;

//    .
GetWindowPlacement(far_handle,@old_place);
old_buf:=con_info.dwSize;

//     **  ,
//       
//    
SystemParametersInfo(SPI_GETWORKAREA,0,@rc,0);
ts.X:=rc.Left;
ts.Y:=rc.Top;

//   max  
cs:=GetLargestConsoleWindowSize(GetStdHandle(STD_OUTPUT_HANDLE));
cs.Y:=cs.Y+1;
if append_bottom then
  cs.Y:=cs.Y+1;

//        
//    ,   
//      ,    
//      , 
//      )
far_rect.Left:=brd_sz;  far_rect.Right:=cs.X*fs.X+brd_sz;
far_rect.Top:=cpt_sz;  far_rect.Bottom:=cs.Y*fs.Y+cpt_sz;

//    ,  ,
//  ""      
//      (
//        )

SetConsoleScreenBufferSize(GetStdHandle(STD_OUTPUT_HANDLE),cs);
SetWindowPos(far_handle,HWND_NOTOPMOST,ts.X-brd_sz,ts.Y-cpt_sz,
  ts.X+fs.X*cs.X+2*brd_sz,ts.Y+fs.Y*cs.Y+cpt_sz+brd_sz,0);
SetWindowRgn(far_handle,CreateRectRgnIndirect(far_rect),true);
SetParent(far_handle,FindWindow('Progman','Program Manager'));
SetWindowLong(far_handle,GWL_EXSTYLE,
  GetWindowLong(far_handle,GWL_EXSTYLE)+WS_EX_TOPMOST);

//    ,   
//      
i:=0;  if show_captions then i:=fs.Y;
r1:=CreateRectRgn(far_rect.Left,far_rect.Top+i,
  brd_sz+(far_rect.Right-far_rect.Left) div 2,
  far_rect.Bottom-2*fs.Y);
r2:=CreateRectRgn(brd_sz+(far_rect.Right-far_rect.Left) div 2,
  far_rect.Top+i,far_rect.Right,far_rect.Bottom-2*fs.Y);
rboth:=CreateRectRgn(far_rect.Left,far_rect.Top+i,
  far_rect.Right,far_rect.Bottom-2*fs.Y);

//    .
//    - .  .

at:=TActivateThread.Create(true);
at.Priority:=tpLowest;
at.FreeOnTerminate:=true;
at.far_handle:=far_handle;
at.Resume;
end;

procedure SetStartupInfo(var psi:TPluginStartupInfo); stdcall;
var
  i,t,s:integer;
  key:HKEY;
begin
Move(psi,far_api,SizeOf(far_api));

//     
t:=REG_DWORD;
s:=SizeOf(i);
RegCreateKey(HKEY_CURRENT_USER,'SOFTWARE\Far\Plugins\FAR Desktop',key);

auto_maximize:=false;  i:=0;
if RegQueryValueEx(key,'MaximizeFAROnStart',nil,@t,@i,@s)=ERROR_SUCCESS then
  auto_maximize:=(i=1)
else
  RegSetValueEx(key,'MaximizeFAROnStart',0,REG_DWORD,@i,s);

show_captions:=false; i:=1;
if RegQueryValueEx(key,'ShowPanelsCaptions',nil,@t,@i,@s)=ERROR_SUCCESS then
  show_captions:=(i=1)
else
  RegSetValueEx(key,'ShowPanelsCaptions',0,REG_DWORD,@i,s);

append_bottom:=false; i:=0;
if RegQueryValueEx(key,'AddStringToBottom',nil,@t,@i,@s)=ERROR_SUCCESS then
  append_bottom:=(i=1)
else
  RegSetValueEx(key,'AddStringToBottom',0,REG_DWORD,@i,s);

RegCloseKey(key);

if auto_maximize then
  MaximizeFAR;

//     
for i:=0 to High(plugin_menu) do
  plugin_menu[i]:=GetMsg(i);
end;

function Configure(ItemNumber:integer):boolean; stdcall;
var
  d:PFarDialogItemArr;
  key:HKEY;
  a:integer;

  procedure InitDialogItems;
  var
    i:integer;
  begin
  for i:=0 to Length(conf_dialog)-1 do
    with d^[i] do
      begin
      ItemType:=conf_dialog[i].ItemType;
      X1:=conf_dialog[i].X1;  Y1:=conf_dialog[i].Y1;
      X2:=conf_dialog[i].X2;  Y2:=conf_dialog[i].Y2;
      Focus:=0;  Flags:=0;
      DefaultButton:=(conf_dialog[i].Data=10);
      if conf_dialog[i].Data=7 then
        Param.Selected:=auto_maximize;
      if conf_dialog[i].Data=8 then
        Param.Selected:=show_captions;
      if conf_dialog[i].Data=9 then
        Param.Selected:=append_bottom;

      FillChar(Data.Data,SizeOf(Data.Data),0);
      if conf_dialog[i].Data<>-1 then
        StrCopy(Data.Data,GetMsg(conf_dialog[i].Data));
      end;
  end;

begin
//      TFarDialogItemArr 
//     ( 
//   ,   :  
//    TFarDialogItemArr  
//    :)).    
//    ,  
//        .

d:=GetMemory(SizeOf(TFarDialogItem)*Length(conf_dialog));
InitDialogItems;
if far_api.Dialog(far_api.ModuleNumber,-1,-1,41,10,
  nil,d,Length(conf_dialog))=4 then
  begin
  RegCreateKey(HKEY_CURRENT_USER,'SOFTWARE\Far\Plugins\FAR Desktop',key);
  a:=0; if d^[1].Param.Selected then a:=1; auto_maximize:=(a=1);
  RegSetValueEx(key,'MaximizeFAROnStart',0,REG_DWORD,@a,SizeOf(a));
  a:=0; if d^[2].Param.Selected then a:=1; show_captions:=(a=1);
  RegSetValueEx(key,'ShowPanelsCaptions',0,REG_DWORD,@a,SizeOf(a));
  a:=0; if d^[3].Param.Selected then a:=1; append_bottom:=(a=1);
  RegSetValueEx(key,'AddStringToBottom',0,REG_DWORD,@a,SizeOf(a));
  RegCloseKey(key);
  end;

FreeMemory(d);
Result:=false;
end;

function OpenPlugin(OpenFrom:integer; Item:integer):THandle; stdcall;
var
  r:HRGN;
  s:string;
  rc:TRect;
begin
Result:=INVALID_HANDLE_VALUE;

//    Double FAR,  
s:=DosToWin(MyExtractFilePath(far_api.ModuleName));
Delete(s,Length(s),1);
s:=MyExtractFilePath(s);
if FileExists(s+'DoubleFAR\lock') then
  Exit;

//    ,
//      
if far_handle=0 then
  begin
  MaximizeFAR;
  Exit;
  end;

//     ,  
//  ,  ,     ,
//       (,  
//   )     
r:=CreateRectRgnIndirect(far_rect);

case far_api.Message(far_api.ModuleNumber,0,nil,@plugin_menu,6,4) of
  0:begin
    if show_p1 then
      CombineRgn(r,r,r1,RGN_DIFF);
    show_p1:=not show_p1;
    show_p2:=true; show_both:=true;
    end;
  1:begin
    if show_p2 then
      CombineRgn(r,r,r2,RGN_DIFF);
    show_p2:=not show_p2;
    show_p1:=true; show_both:=true;
    end;
  2:begin
    if show_both then
      CombineRgn(r,r,rboth,RGN_DIFF);
    show_both:=not show_both;
    show_p1:=true; show_p2:=true;
    end;
  3:begin
    rc.Left:=far_rect.Left-brd_sz;
    rc.Right:=far_rect.Right+brd_sz;
    rc.Top:=far_rect.Top-cpt_sz;
    rc.Bottom:=far_rect.Bottom+brd_sz;
    DeleteObject(r);
    r:=CreateRectRgnIndirect(rc);
    SetWindowRgn(far_handle,r,true);
    SetWindowPlacement(far_handle,@old_place);
    SetConsoleScreenBufferSize(GetStdHandle(
      STD_OUTPUT_HANDLE),old_buf);
    SetWindowPlacement(far_handle,@old_place);
    SetParent(far_handle,0);
    SetWindowLong(far_handle,GWL_EXSTYLE,
      GetWindowLong(far_handle,GWL_EXSTYLE)-WS_EX_TOPMOST);
    at.Suspend;
    at.Terminate;
    far_handle:=0;
    Exit;
    end;
end;

//      
//     (,    
//  GDI-,  )
SetWindowRgn(far_handle,r,true);
DeleteObject(r);
end;

procedure ClosePlugin(hPlugin:THandle); stdcall;
begin
//        
DeleteObject(r1);
DeleteObject(r1);
DeleteObject(rboth);
end;

exports
  GetPluginInfo,
  SetStartupInfo,
  Configure,
  OpenPlugin,
  ClosePlugin;

end.
